VERSION 4.00
Begin VB.Form frmDownMan 
   Caption         =   "GEM Download Manager"
   ClientHeight    =   5940
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   8670
   Height          =   6630
   Icon            =   "GEMDnld.frx":0000
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   5940
   ScaleWidth      =   8670
   Top             =   1170
   Width           =   8790
   Begin ComctlLib.ImageList ImageList1 
      Left            =   7920
      Top             =   3000
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   8388736
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   2
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "GEMDnld.frx":0442
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "GEMDnld.frx":0554
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   300
      Left            =   0
      TabIndex        =   1
      Top             =   5640
      Width           =   8670
      _ExtentX        =   15293
      _ExtentY        =   529
      Style           =   1
      SimpleText      =   "Ready"
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin ComctlLib.ListView ListView1 
      Height          =   5655
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6615
      _ExtentX        =   11668
      _ExtentY        =   9975
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      SmallIcons      =   "ImageList1"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   "Name"
         Object.Tag             =   ""
         Text            =   "Name"
         Object.Width           =   3863
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   "Size"
         Object.Tag             =   ""
         Text            =   "Size"
         Object.Width           =   1667
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   "Description"
         Object.Tag             =   ""
         Text            =   "Description"
         Object.Width           =   7726
      EndProperty
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFRefresh 
         Caption         =   "&Refresh"
      End
      Begin VB.Menu mnuFSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuDownload 
      Caption         =   "&Download"
      Begin VB.Menu mnuDDownload 
         Caption         =   "&Download Selected File..."
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHAbout 
         Caption         =   "&About GEM Download Manager..."
      End
   End
End
Attribute VB_Name = "frmDownMan"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' GEM Download Manager                                       '
' Version 1.0                                                '
' Copyright (c) Owen Rudge 2000                              '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This software is licenced under the GNU Public License.    '
' Please see LICENSE.TXT for further information.            '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Const URLName = "URL.TXT"
Const FileListName = "FileList.txt"

' SUB: ParseFileList
'
' Parses the file list (FILELIST.TXT) and adds the items to the ListView
Sub ParseFileList()
    Dim FLine As String
    Dim FL As Integer
    Dim SepPlaces(3) As Integer
    
    FL = FreeFile
    
    Open FileListName For Input As #FL
    
    Do Until EOF(FL)
        Line Input #FL, FLine
        If Left$(FLine, 1) <> "#" Then   ' not a comment
            SepPlaces(1) = InStr(1, FLine, "<=1=>", 1) - 1
            SepPlaces(2) = InStr(SepPlaces(1), FLine, "<=2=>", 1) - 1
            SepPlaces(3) = InStr(SepPlaces(2), FLine, "<=3=>", 1) - 1
            
            ListView1.ListItems.Add , , Left$(FLine, SepPlaces(1))  ' label
            ListView1.ListItems(ListView1.ListItems.Count).SubItems(1) = Right$(Left$(FLine, SepPlaces(2)), Len(Left$(FLine, SepPlaces(2))) - (Len(Left$(FLine, SepPlaces(1))) + 5)) ' sort out mess of size
            ListView1.ListItems(ListView1.ListItems.Count).SubItems(2) = Right$(Left$(FLine, SepPlaces(3)), Len(Left$(FLine, SepPlaces(3))) - (Len(Left$(FLine, SepPlaces(2))) + 5)) ' sort out mess of description
            ListView1.ListItems(ListView1.ListItems.Count).Tag = Trim$(Right$(FLine, Len(FLine) - Len(Left$(FLine, SepPlaces(3))) - 5)) ' do the same for URL, but assign to Tag
            
            If Trim$(ListView1.ListItems(ListView1.ListItems.Count).SubItems(1)) = "" Then
                If Trim$(ListView1.ListItems(ListView1.ListItems.Count).Text) <> "" Then
                    ListView1.ListItems(ListView1.ListItems.Count).SmallIcon = 2
                End If
            Else
                ListView1.ListItems(ListView1.ListItems.Count).SmallIcon = 1
            End If
        End If
    Loop
    
    Close
End Sub


Private Sub Form_Load()
    Dim strURL As String
    Dim netConnection As New CWinInet
    
    Form_Resize
    Show
    
    Screen.MousePointer = 11
    
    ' Read URL.TXT to get url of file list
    Open URLName For Input As #1
    Line Input #1, strURL
    Close #1
        
    netConnection.Init
    netConnection.ReadUrl strURL, FileListName, "file list"
    netConnection.Term
    
    ParseFileList

    Screen.MousePointer = 0
End Sub

Private Sub Form_Resize()
    ListView1.Width = ScaleWidth
    ListView1.Height = ScaleHeight - StatusBar1.Height
End Sub




Private Sub mnuDDownload_Click()
    On Error Resume Next
    
    Dim FrFi As Integer
    FrFi = FreeFile
    
    Open "DOWNLOAD.LOG" For Append As #FrFi
    Print #FrFi, "Download Started: " & Date & " " & Time & " - " & ListView1.SelectedItem.Tag
    Close #FrFi
    
    x = ShellExecute(hwnd, "open", ListView1.SelectedItem.Tag, "", "", 1)
End Sub


Private Sub mnuFExit_Click()
    Unload Me
End Sub

Private Sub mnuFRefresh_Click()
    Dim strURL As String
    Dim netConnection As New CWinInet
    
    ListView1.ListItems.Clear

    Screen.MousePointer = 11
    
    ' Read URL.TXT to get url of file list
    Open URLName For Input As #1
    Line Input #1, strURL
    Close #1
        
    netConnection.Init
    netConnection.ReadUrl strURL, FileListName, "file list"
    netConnection.Term
    
    ParseFileList

    Screen.MousePointer = 0
End Sub


Private Sub mnuHAbout_Click()
    frmAbout.Show 1
End Sub


